/*
   Siag, Scheme In A Grid
   Copyright (C) 2000  Ulric Eriksson <ulric@siag.nu>
 
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.
 
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.
 */

#include "../config.h"

#ifdef HAVE_LIBLAGO

/* Highly experimental! */

#include <stdio.h>
#include <stdlib.h>
#include <lago.h>
#include "../siod/siod.h"
#include "calc.h"

static char *host = "127.0.0.1";
static char *port = "7412";
static char *database = "siag";
static char *user = "siag";
static char *password = "siag";

static LISP store_result(buffer *buf, int sht, int row, int col, LRST resultset)
{
	int i, n;
	cval val;
	char *p;
	LISP res = NIL;

	val.number = 0;
	if (resultset == 0) return NIL;
	n = Lgetncols(resultset);
	if (n == 0) printf("no columns in resultset\n");

	while (Lfetch(resultset) == LFETCH_MORE) {
		for (i = 1; i <= n; i++) {
			p = (char *)Lgetasstr(resultset, i);
			if (res == NIL) {
				res = strcons(strlen(p), p);
			} else {
				ins_data(buf, siod_interpreter,
					p, val, MTEXT, sht, row, col+i-1);
			}
		}
		row++;
	}
	return res;
}

static LISP lago_query(LISP query)
{
	int row, col, sht;
	buffer *buf;
	int n;
	char *q = get_c_string(query);
	LCTX context = Lnewctx();
	LRST resultset;
	LISP res;
	get_siod_coords(&row, &col, &sht, &buf);
	n = Lconnect(context, host, port, database, user, password);
	if (n) {
		Ldelctx(context);
		return NIL;
	}

	resultset = Lquery(context, q);
	if (resultset == 0) {
		Ldelctx(context);
		return NIL;
	}
	res = store_result(buf, sht, row, col, resultset);
	Ldelctx(context);
	return res;
}

void init_lago(void)
{
	init_subr_1("lago_query", lago_query);
}

#else

void init_lago(void)
{
	;
}

#endif	/* LAGO */

